/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003-2004  Ciaran Anscomb
 *
 *  See COPYING for redistribution conditions. */

#ifndef __KEYBOARD_H__
#define __KEYBOARD_H__

#include "types.h"

/* These contain masks to be applied when the corresponding row/column is
 * held low.  eg, if row 1 is outputting a 0 , keyboard_column[1] will
 * be applied on column reads */
extern uint_fast8_t keyboard_column[8];
extern uint_fast8_t keyboard_row[8];

void keyboard_init(void);
void keyboard_reset(void);
void keyboard_column_update(void);
void keyboard_row_update(void);

void keyboard_init_arch(void);
void keyboard_poll(void);

#endif  /* __KEYBOARD_H__ */
