/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003-2004  Ciaran Anscomb
 *
 *  See COPYING for redistribution conditions. */

#ifndef __VIDEO_H__
#define __VIDEO_H__

#ifdef GP32
# include "video_gp32.h"
#else
# include "video_sdl.h"
#endif

#include "types.h"

typedef struct {
	uint_fast16_t w, h;
	Pixel *data;
} Sprite;

void video_init(void);
void video_shutdown(void);
void video_fillrect(uint_fast16_t x, uint_fast16_t y, uint_fast16_t w, uint_fast16_t h, Pixel colour);
void video_blit(uint_fast16_t x, uint_fast16_t y, Sprite *src);
void video_backup(void);
void video_restore(void);

#endif  /* __VIDEO_H__ */
